<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
    <link rel="stylesheet" href="../CSS/reset.css">
    <link rel="stylesheet" href="../CSS/html-basic.css">
</head>
<body>
        <h1>HTML Intermédiaire</h1>

        <section class="css_core">
            <h2>Au coeur de CSS</h2>
    
            <article>
                <h3>Cascade</h3>
                <p>Les styles CSS sont chargés les un à la suite des autres et s'appliquent en cascade.
                    La <a href="https://www.w3.org/TR/css3-cascade/#cascade">cascade est un algorithme</a> qui trie les selecteurs par précédence de déclaration.
                </p>
            </article>
            <article>
                <h3>Héritage (inheritance)</h3>
                <p>Propage les propriétés des parents aux enfants. Certaines propriétés sont héritées par défaut (ex: la typographie).
                    Une propriété peut également être héritée via le mot clé <a href="https://www.w3.org/TR/css3-cascade/#valdef-all-inherit">inherit</a>.
                </p>
            </article>
            <article>
                <h3>Spécificité (specificity)</h3>
                <p>La spécificité d'un selector est calculé via <a href="https://www.w3.org/TR/2018/REC-selectors-3-20181106/#specificity">un algorithme</a>
                    et permet de déterminer la précédence d'un selecteur par rapport à un autre.</p>
            </article>
            <article>
                <h3>Ressources</h3>
                <ul>
                    <li>Cascade: <a href="https://www.w3.org/TR/css-cascade-3/">https://www.w3.org/TR/css-cascade-3/</a>, <a href="https://www.w3.org/TR/css3-cascade/#cascade">https://www.w3.org/TR/css3-cascade/#cascade</a>, <a href="https://css-tricks.com/the-c-in-css-the-cascade/">https://css-tricks.com/the-c-in-css-the-cascade/</a></li>
                    <li>Inheritance: <a href="https://www.w3.org/TR/css-cascade-3/">https://www.w3.org/TR/css-cascade-3/</a>, <a href="https://www.w3.org/TR/css3-cascade/#inheriting">https://www.w3.org/TR/css3-cascade/#inheriting</a></li>
                    <li>Specificity: <a href="https://www.w3.org/TR/2018/REC-selectors-3-20181106/#specificity">https://www.w3.org/TR/2018/REC-selectors-3-20181106/#specificity</a></li>
                </ul>
            </article>
        </section>

        <section class="css_specifications">
            <h2>Spécifications Intéressantes</h2>
            <article>
                <p>L'ensemble des spécifications CSS est disponible sur ce lien: <a href="https://www.w3.org/TR/CSS/#css">https://www.w3.org/TR/CSS/#css</a></p>
            </article>
            <article>
                <h3>Layouts</h3>
                <p>CSS 3 et 4 fournissent enfin des technologies de mise en page</p>
                <ul>
                    <li>Flexbox: <a href="https://www.w3.org/TR/css-flexbox-1">https://www.w3.org/TR/css-flexbox-1</a>, <a href="https://philipwalton.github.io/solved-by-flexbox/">solved by flexbox</a></li>
                    <li>CSS Grid: <a href="https://www.w3.org/TR/css-grid-1">https://www.w3.org/TR/css-grid-1</a>, <a href="https://gridbyexample.com/examples/">grid examples</a></li>
                </ul>
                <p>Pour apprendre d'autres techniques de positionnement, aller voir <a href="http://www.learnlayout.com/">http://www.learnlayout.com/</a></p>
            </article>
            <article>
                <h3>CSS Fonts</h3>
                <p>CSS permet de charger des fontes externes</p>
                <ul>
                    <li>CSS Fonts: <a href="https://www.w3.org/TR/2018/REC-css-fonts-3-20180920/">CSS Fonts</a></li>
                    <li>Google Fonts: <a href="https://fonts.google.com">https://fonts.google.com</a></li>
                </ul>
            </article>
            <article>
                <h3>CSS Media Queries</h3>
                <p>Pour déclencher des règles CSS en fonction de conditions liées au média. Très utile lorsque l'on fait du responsive design</p>
                <ul>
                    <li>Media Queries<a href="https://www.w3.org/TR/css3-mediaqueries/">CSS Media Queries</a></li>
                </ul>
            </article>
        </section>

        <section class="methodo">
                <h2>Outils et méthodologies</h2>
        
                <article>
                    <h3>Browser sync</h3>
                    <p>Browser-sync permet de reloader automatiquement 
                        le contenu d'un navigateur si le code source change.</p>
                    <ul>
                        <li><a href="https://www.browsersync.io/">https://www.browsersync.io/</a></li>
                    </ul> 
                </article>
                <article>
                    <h3>Méthodologies</h3>
                    <p>Des méthodologies CSS permettent de structurer son code HTML / CSS, 
                        et de mettre en place une approche par composants proche d'un modèle UI plus traditionnel.
                    </p>
                    <ul>
                        <li>BEM: <a href="http://getbem.com/">BEM</a></li>
                        <li>Autres méthodologies: <a href="http://getbem.com/introduction/">SMACSS, OOCSS, Atomic,...</a></li>
                    </ul> 
                </article>
                <article>
                    <h3>Frameworks CSS</h3>
                    <p>Les frameworks CSS permettent de gagner du temps en fournissant une base solide de feuilles de styles CSS et de scripts JavaScript afin de créer des UI webs</p>
                    <ul>
                        <li><a href="https://getbootstrap.com">Twitter Bootstrap</a></li>
                        <li><a href="https://foundation.zurb.com/">Zurb</a></li>
                    </ul> 
                </article>
                <article>
                    <h3>caniuse.com</h3>
                    <p>caniuse.com permet de vérifier si une fonctionnalité HTML, CSS ou JavaScript est disponible dans un navigateur donné.</p>
                    <ul>
                        <li><a href="https://caniuse.com/">Can I Use .com</a></li>
                    </ul> 
                </article>
        </section>
</body>
</html>